Package javax.help

# Class JHelpNavigator

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.help.JHelpNavigator

All Implemented Interfaces:
  `ImageObserver`, `MenuContainer`, `Serializable`, `Accessible`

Direct Known Subclasses:
  `JHelpFavoritesNavigator`, `JHelpGlossaryNavigator`, `JHelpIndexNavigator`, `JHelpSearchNavigator`, `JHelpTOCNavigator`

public class JHelpNavigator extends JComponent implements Accessible
A JHelpNavigator is a control that presents navigational help data. It is identified by a type and it interacts with a HelpModel. There are three JHelpNavigators that most JavaHelp implementations should support:

See Also:
  - `JHelpTOCNavigator`
  - `JHelpIndexNavigator`
  - `This class is intended to be extended. To use this class by itself requires a platform look and feel (plaf) class that extends `javax.help.plaf.HelpNavigatorUI`. Additionally, the UIDefaults table requires an entry for "HelpViewerUI" that points to the plaf class.`
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`protected class`
`JHelpNavigator.AccessibleJHelpNavigator`
The class used to obtain the accessible role for this object.

## Nested classes/interfaces inherited from class javax.swing.JComponent

`JComponent.AccessibleJComponent`

## Nested classes/interfaces inherited from class java.awt.Container

`Container.AccessibleAWTContainer`

## Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected HelpModel`
`helpModel`
`protected String`
`type`

### Fields inherited from class javax.swing.JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class java.awt.Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

## Constructor Summary

Constructors
Constructor
Description
`JHelpNavigator(NavigatorView view)`
Returns a JHelpNavigator with an instance of DefaultHelpModel as its data model.
`JHelpNavigator(NavigatorView view, HelpModel model)`
Constructs a JHelpNavigator from some view and with a preexisting model and in default initial state of navigation entries.

## Method Summary

Modifier and Type
Method
Description
`void`
`addHelpModelListener(HelpModelListener l)`
Adds a listener for the HelpModelEvent posted after the model has changed.
`boolean`
`canMerge(NavigatorView view)`
Determines if this instance of a JHelpNavigator can merge its data with another one.
`protected static Hashtable`
`createParams(URL data)`
Creates the parameters for a Navigator from data stored in a URL.
`AccessibleContext`
`getAccessibleContext()`
Get the AccessibleContext associated with this JComponent.
`Icon`
`getIcon()`
Gets an icon to identify this Navigator.
`HelpModel`
`getModel()`
Returns the HelpModel that provides the data.
`String`
`getNavigatorLabel()`
Gets the name of this navigator view.
`String`
`getNavigatorLabel(Locale locale)`
Gets locale-dependent name for this navigator view.
`String`
`getNavigatorName()`
Names this Navigator.
`NavigatorView`
`getNavigatorView()`
Gets the NavigatorView that created this Navigator View.
`TreeItem[]`
`getSelectedItems()`
Returns a list of selected items
`HelpNavigatorUI`
`getUI()`
Returns the HelpUI that provides the current look and feel.
`String`
`getUIClassID()`
`void`
`merge(NavigatorView view)`
Merged a NavigatorView into this instance.
`void`
`remove(NavigatorView view)`
Removes a NavigatorView from this instance.
`void`
`removeHelpModelListener(HelpModelListener l)`
Removes a listener previously added with `addHelpModelListener`.
`void`
`setModel(HelpModel newModel)`
Sets the HelpModel that provides the data.
`void`
`setSelectedItems(TreeItem[] selectedItems)`
Sets the list of selected items
`void`
`setUI(HelpNavigatorUI ui)`
Sets the HelpUI that provides the current look and feel.
`void`
`updateUI()`
Replaces the UI with the latest version from the default UIFactory.

### Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, paramString, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### helpModel

protected HelpModel helpModel

### type

protected String type

## Constructor Details

### JHelpNavigator

public JHelpNavigator(NavigatorView view)
Returns a JHelpNavigator with an instance of DefaultHelpModel as its data model.

Parameters:
  `view` - The NavigatorView to use. If `view` is null it creates a JHelpTOCNavigator with a null NavigatorView.

### JHelpNavigator

public JHelpNavigator(NavigatorView view, HelpModel model)
Constructs a JHelpNavigator from some view and with a preexisting model and in default initial state of navigation entries.

Parameters:
  `view` - The NavigatorView. If `view` is null it creates a JHelpNavigator with a null NavigatorView.
  `model` - The model that generates changes. If `model` is null it creates a JHelpNavigator without a model.

## Method Details

### getSelectedItems

public TreeItem[] getSelectedItems()
Returns a list of selected items

### setSelectedItems

public void setSelectedItems(TreeItem[] selectedItems)
Sets the list of selected items

### getUIClassID

public String getUIClassID()

Overrides:
  `getUIClassID` in class `JComponent`
Returns:
  "HelpNavigatorUI"

### canMerge

public boolean canMerge(NavigatorView view)
Determines if this instance of a JHelpNavigator can merge its data with another one.

Parameters:
  `view` - The data to merge.
Returns:
  Whether it can be merged.
See Also:
  - `merge(javax.help.NavigatorView)`
  - `remove(javax.help.NavigatorView)`

### merge

public void merge(NavigatorView view)
Merged a NavigatorView into this instance.

Parameters:
  `view` - The data to merge
Throws:
  `UnsupportedOperationException`
See Also:
  - `canMerge(javax.help.NavigatorView)`
  - `remove(javax.help.NavigatorView)`

### remove

public void remove(NavigatorView view)
Removes a NavigatorView from this instance.

Parameters:
  `view` - The data to merge
Throws:
  `UnsupportedOperationException`
See Also:
  - `canMerge(javax.help.NavigatorView)`
  - `merge(javax.help.NavigatorView)`

### getNavigatorName

public String getNavigatorName()
Names this Navigator.

Returns:
  The name of this Navigator. This is locale independent and can be used by the application to identify the view.

### getNavigatorView

public NavigatorView getNavigatorView()
Gets the NavigatorView that created this Navigator View.

Returns:
  the NavigatorView

### getNavigatorLabel

public String getNavigatorLabel()
Gets the name of this navigator view.

Returns:
  The label for this NavigatorView.

### getNavigatorLabel

public String getNavigatorLabel(Locale locale)
Gets locale-dependent name for this navigator view.

Returns:
  the label for this NavigatorView. If locale is null it is treated as the default Locale.

### getIcon

public Icon getIcon()
Gets an icon to identify this Navigator. Currently this is a read-only property.

Returns:
  An icon to identify this navigator.

### setModel

public void setModel(HelpModel newModel)
Sets the HelpModel that provides the data.

Parameters:
  `newModel` - The HelpModel for this component. A null for newModel is valid.

### getModel

public HelpModel getModel()
Returns the HelpModel that provides the data.

### setUI

public void setUI(HelpNavigatorUI ui)
Sets the HelpUI that provides the current look and feel.

### getUI

public HelpNavigatorUI getUI()
Returns the HelpUI that provides the current look and feel.

Overrides:
  `getUI` in class `JComponent`

### updateUI

public void updateUI()
Replaces the UI with the latest version from the default UIFactory.

Overrides:
  `updateUI` in class `JComponent`

### addHelpModelListener

public void addHelpModelListener(HelpModelListener l)
Adds a listener for the HelpModelEvent posted after the model has changed.

Parameters:
  `l` - - The listener to add.
See Also:
  - `HelpModel.removeHelpModelListener(javax.help.event.HelpModelListener)`

### removeHelpModelListener

public void removeHelpModelListener(HelpModelListener l)
Removes a listener previously added with `addHelpModelListener`.

Parameters:
  `l` - - The listener to remove.
See Also:
  - `HelpModel.addHelpModelListener(javax.help.event.HelpModelListener)`

### createParams

protected static Hashtable createParams(URL data)
Creates the parameters for a Navigator from data stored in a URL.

Returns:
  A Hashtable of parameters

### getAccessibleContext

public AccessibleContext getAccessibleContext()
Get the AccessibleContext associated with this JComponent.

Specified by:
  `getAccessibleContext` in interface `Accessible`
Overrides:
  `getAccessibleContext` in class `Component`
Returns:
  The AccessibleContext of this JComponent